import { IGroup } from '@antv/g-base/lib/interfaces';
import GroupComponent from '../abstract/group-component';
import { ILocation } from '../interfaces';
import { RegionAnnotationCfg, RegionLocationCfg } from '../types';
declare class RegionAnnotation extends GroupComponent<RegionAnnotationCfg> implements ILocation<RegionLocationCfg> {
    /**
     * @protected
     * 默认的配置项
     * @returns {object} 默认的配置项
     */
    getDefaultCfg(): {
        name: string;
        type: string;
        locationType: string;
        start: any;
        end: any;
        style: {};
        defaultCfg: {
            style: {
                lineWidth: number;
                fill: string;
                opacity: number;
            };
        };
        container: any;
        shapesMap: {};
        group: any;
        capture: boolean;
        isRegister: boolean;
        id: string;
        offsetX: number;
        offsetY: number;
        animate: boolean;
        animateCfg: {
            duration: number;
            easing: string;
        };
        events: any;
        visible: boolean;
    };
    protected renderInner(group: IGroup): void;
    private renderRegion;
}
export default RegionAnnotation;
