import { transform, vec3 } from '@antv/matrix-util';
var identityMatrix = [1, 0, 0, 0, 1, 0, 0, 0, 1];
export function getMatrixByAngle(point, angle) {
    if (!angle) {
        // 角度为 0 或者 null 时返回 null
        return null;
    }
    var m = transform(identityMatrix, [
        ['t', -point.x, -point.y],
        ['r', angle],
        ['t', point.x, point.y],
    ]);
    return m;
}
export function getMatrixByTranslate(point) {
    if (!point.x && !point.y) {
        // 0，0 或者 nan 的情况下返回 null
        return null;
    }
    return transform(identityMatrix, [['t', point.x, point.y]]);
}
// 从矩阵获取旋转的角度
export function getAngleByMatrix(matrix) {
    var xVector = [1, 0, 0];
    var out = [];
    vec3.transformMat3(out, xVector, matrix);
    return Math.atan2(out[1], out[0]);
}
//# sourceMappingURL=matrix.js.map