import { IGroup } from '@antv/g-base/lib/interfaces';
import GroupComponent from '../abstract/group-component';
import { ILocation } from '../interfaces';
import { PointLocationCfg, TextAnnotationCfg } from '../types';
declare class TextAnnotation extends GroupComponent<TextAnnotationCfg> implements ILocation<PointLocationCfg> {
    /**
     * @protected
     * 默认的配置项
     * @returns {object} 默认的配置项
     */
    getDefaultCfg(): {
        name: string;
        type: string;
        locationType: string;
        x: number;
        y: number;
        content: string;
        style: {};
        defaultCfg: {
            style: {
                fill: string;
                fontSize: number;
                textAlign: string;
                textBaseline: string;
                fontFamily: string;
            };
        };
        container: any;
        shapesMap: {};
        group: any;
        capture: boolean;
        isRegister: boolean;
        id: string;
        offsetX: number;
        offsetY: number;
        animate: boolean;
        animateCfg: {
            duration: number;
            easing: string;
        };
        events: any;
        visible: boolean;
    };
    setLocation(location: PointLocationCfg): void;
    protected renderInner(group: IGroup): void;
    private renderText;
    private resetLocation;
}
export default TextAnnotation;
