"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var matrix_util_1 = require("@antv/matrix-util");
var identityMatrix = [1, 0, 0, 0, 1, 0, 0, 0, 1];
function getMatrixByAngle(point, angle) {
    if (!angle) {
        // 角度为 0 或者 null 时返回 null
        return null;
    }
    var m = matrix_util_1.transform(identityMatrix, [
        ['t', -point.x, -point.y],
        ['r', angle],
        ['t', point.x, point.y],
    ]);
    return m;
}
exports.getMatrixByAngle = getMatrixByAngle;
function getMatrixByTranslate(point) {
    if (!point.x && !point.y) {
        // 0，0 或者 nan 的情况下返回 null
        return null;
    }
    return matrix_util_1.transform(identityMatrix, [['t', point.x, point.y]]);
}
exports.getMatrixByTranslate = getMatrixByTranslate;
// 从矩阵获取旋转的角度
function getAngleByMatrix(matrix) {
    var xVector = [1, 0, 0];
    var out = [];
    matrix_util_1.vec3.transformMat3(out, xVector, matrix);
    return Math.atan2(out[1], out[0]);
}
exports.getAngleByMatrix = getAngleByMatrix;
//# sourceMappingURL=matrix.js.map